routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Route::get('/setting', 'HomeController@setting')->name('setting');

Route::get('/user', 'UserController@index')->name('user');
Route::get('/user/add', 'UserController@add')->name('user.add');
Route::post('/user/change_status', 'UserController@change_status')->name('user.change_status');
Route::get('/user/{id}', 'UserController@single')->name('user.single');
Route::post('/user/insert', 'UserController@insert')->name('user.insert');
Route::get('/user/edit/{id}', 'UserController@edit')->name('user.edit');
Route::post('/user/edit_insert', 'UserController@edit_insert')->name('user.edit_insert');
Route::post('users/action', 'UserController@action');
Route::post('users/send_bulk_emails', 'UserController@send_bulk_emails')->name('send.bulk.emails');


Route::get('/app', 'ApplicationController@index')->name('app');
Route::get('/app/add', 'ApplicationController@add')->name('app.add');
Route::get('/app/edit/{id}', 'ApplicationController@edit')->name('app.edit');
Route::post('/app/insert', 'ApplicationController@insert')->name('app.insert');
Route::post('/app/insert_edit', 'ApplicationController@insert_edit')->name('app.insert_edit');
Route::post('/app/add_media', 'ApplicationController@add_media')->name('app.add_media');
Route::get('/app/{id}', 'ApplicationController@single');
Route::post('app/action', 'ApplicationController@action');
Route::post('app/add_comment', 'ApplicationController@add_comment')->name('app.add_comment');



Route::get('/doc', 'DocumentManagerController@index')->name('doc');
Route::get('/doc/add', 'DocumentManagerController@add')->name('doc.add');
Route::post('/doc/insert', 'DocumentManagerController@insert')->name('doc.insert');
Route::post('doc/action', 'DocumentManagerController@action');

Route::get('import_export/', 'HomeController@import_export');
Route::post('export/users', 'HomeController@export_users')->name('user.export');
Route::post('import/users', 'HomeController@import_users')->name('user.import');

Route::post('export/app', 'HomeController@export_app')->name('app.export');
Route::post('import/app', 'HomeController@import_app')->name('app.import');

Route::middleware(['auth'])->group(function () {
    Route::post('/doc/create/folder', 'DocumentManagerController@createNewFolder')->name('create.folder');
    Route::post('/doc/get/sub/folders', 'DocumentManagerController@getSubFolders')->name('get.subfolders');
    Route::post('/doc/delet/folders', 'DocumentManagerController@deleteFolders')->name('delete.folder');
    Route::post('/doc/delet/file', 'DocumentManagerController@deleteFile')->name('delete.file');

    Route::post('/doc/upload', 'DocumentManagerController@uploadDocument')->name('document.upload');

    Route::get('/doc/download/{id}', 'DocumentManagerController@downloadDocument')->name('document.download');
});

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'first_name','last_name','display_name', 'company_name', 'phone_no', 'status', 'role', 'media_id','email', 'created_by', 'updated_by','created_at','updated_at',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    // add media_object relationship
    public function media_object()
    {
        return $this->hasOne(Media::class, 'id','media_id');
    }
    public function medias(){
        return $this->hasMany(Media::class);
    }

    /**
     * Get the user's full name.
     *
     * @return string
     */
    public function getIsAdminAttribute()
    {
        return $this->role == 'admin' ? true : false;
    }
}

resources/views/doc/add.blade.php
@extends('layouts.default')
@section('content')

    <div class="main-panel">
        <div class="main-content">
            <div class="content-wrapper">

                <div class="row justify-content-md-center">

                    @if(\Illuminate\Support\Facades\Session::has('info'))
                        <div class="alert alert-success"> <span class="glyphicon glyphicon-ok"></span> <em style="color: white"> {!! session('info') !!}</em> </div>
                    @endif

                    <div class="col-md-12">
                        <div class="card">
                            <div class="card-header">
                                <h4 class="card-title" id="bordered-layout-card-center">Add File</h4>
                            </div>
                            <div class="card-body">
                                <div class="px-3">

                                    {!!Form::open(['url' => route('doc.insert'), 'enctype' => 'multipart/form-data', 'id' => 'user_form', 'class' => 'form form-horizontal form-bordered' ]) !!}

                                    <div class="form-body">
                                        <input type="hidden" name="app_id" val="{{ app('request')->input('app_id') }}"/>
                                        <div class="form-group row">
                                            <label class="col-md-3 label-control" for="eventRegInput1"> File Title: </label>
                                            <div class="col-md-9">
                                                {!! Form::text('title', null, array('class'=>'form-control input-lg',)) !!}
                                                <span class="danger"> @if ($errors->has('title')) {{ $errors->first('title') }} @endif </span>
                                            </div>
                                        </div>

                                        <div class="form-group row">
                                            <label class="col-md-3 label-control" for="eventRegInput1"> Description: </label>
                                            <div class="col-md-9">
                                                {!! Form::textarea('comment', null, array('class'=>'form-control input-lg',)) !!}
                                            </div>
                                        </div>

                                        <div class="form-group row">
                                            <label class="col-md-3 label-control" for="eventRegInput1"> Upload Document: </label>
                                            <div class="col-md-9">
                                                {!! Form::file('pic', null, array('class'=>'form-control input-lg',)) !!}
                                                <span class="danger"> @if ($errors->has('pic')) {{ $errors->first('pic') }} @endif </span>
                                            </div>
                                        </div>

                                        <div class="form-group row">
                                            <div>
                                                <div class="col-md-12 form-group">
                                                    <button type="submit" class="btn btn-info btn-success submit_btn">Save</button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    {{ Form::close() }}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
@endsection

resources/views/doc/all.blade.php
<div id="repo">
    @if(Auth::user()->is_admin)
        <button type="button" id="open-file-section" data-uid="{{$user->id}}" class="btn btn-raised btn-success btn-min-width mr-1 mb-1">
            <a href="javascript:void(0)" style="color: white">Add New Document</a>
        </button>
        <button type="button" id="new-folder" data-uid="{{$user->id}}" class="btn btn-raised btn-success btn-min-width mr-1 mb-1">
            <a href="javascript:void(0)" style="color: white">New Folder</a>
        </button>
    @endif
    <div id="repo-hide">
        <div id="folder-area">
            @include('directory')
        </div>
        <div id="files-area">
            <div class="row d-flex m-0">
                @include('doc/directory_files')
            </div>
            {{--            @include('doc/directory_files')--}}
        </div>
    </div>
</div>

resources/views/doc/directory_files.blade.php
<div class="all-folders-row d-flex">
    @foreach($files as $file)
        <div class="folder-block mr-5 folder">
            @if($file->extension == 'pdf')
                {{-- <i class="fa fa-download download-icon" aria-hidden="true"></i> --}}
                {{-- <i class="fa fa-minus-square-o delete-icon" aria-hidden="true"></i> --}}
                <div class="folder-wrapper" data-id="{{$file->id}}" >
                    <a href="{{route('document.download', [$file->id])}}">
                        <img width="60px" src="{{asset('images/pdf.png')}}">
                    </a>
                    <div class="menu">
                        {{$file->title}} <i class="fa fa-minus-square-o delete-file" aria-hidden="true"></i>
                    </div>
                </div>
            @elseif($file->extension == 'doc' || $file->extension == 'xls' || $file->extension == 'xlsx' || $file->extension == 'docx')
                <div class="folder-wrapper" data-id="{{$file->id}}" >
                    <a href="{{route('document.download', [$file->id])}}">
                        <img width="60px" src="{{asset('images/file.png')}}">
                    </a>
                    <div class="menu">
                        {{$file->title}} <i class="fa fa-minus-square-o delete-file" aria-hidden="true"></i>
                    </div>
                </div>
            @else
                <div class="folder-wrapper" data-id="{{$file->id}}" >
                    <a href="{{route('document.download', [$file->id])}}">
                        <img width="80px" src="{{asset('storage/'.$file->base_url.'/'.$file->name)}}">
                    </a>
                    <div class="menu">
                        {{$file->title}} <i class="fa fa-minus-square-o delete-file" style="color:red" aria-hidden="true"></i>
                    </div>
                </div>
            @endif
            <input class="file-id" type="hidden" value="{{$file->id}}">
            <input class="file_user_id" type="hidden" value="{{$file->user_id}}">
        </div>
    @endforeach

</div>

resources/views/doc/file.blade.php
<style>
    .required label:after {
        color: #e32;
        content: ' *';
        display:inline;
    }
    /*.progress { position:relative; width:100%; border: 1px solid #7F98B2; padding: 1px; border-radius: 3px; }*/
    /*.bar { background-color: #B4F5B4; width:0%; height:25px; border-radius: 3px; }*/
    /*.percent { position:absolute; display:inline-block; top:3px; left:48%; color: #7F98B2;}*/
    /*#loadingMessage {*/
    /*    position: absolute;*/
    /*    top: 2px;*/
    /*    left: 2px;*/
    /*    z-Index: 1050;*/
    /*}*/
</style>
<div class="px-3">

    {!!Form::open(['url' => route('doc.insert'), 'enctype' => 'multipart/form-data', 'id' => 'document_upload', 'class' => 'form form-horizontal form-bordered' ]) !!}

    <div class="form-body">

        <div class="form-group required row">
            <label class="col-md-3 label-control" for="eventRegInput1"> Upload Document: </label>
            <div class="col-md-9">
                {{--                    {!! Form::file('pic', null, array('class'=>'form-control input-lg', 'mulitple' => true)) !!}--}}
                <input type="file" name="pic[]" id="pic" value="pic" multiple="multiple" required>
                <span class="danger">  @if ($errors->has('pic')) {{ $errors->first('pic') }} @endif </span>

{{--                <span id="loadingMessage" style="visibility:hidden;">This page be uploading!</span>--}}
            </div>
{{--            <div class="progress">--}}
{{--                <div class="bar"></div >--}}
{{--                <div class="percent">0%</div >--}}
{{--            </div>--}}

        </div>
        <div class="form-group row">
            <div>
                <div class="col-md-12 form-group">
                    <button type="submit" class="btn btn-info btn-success submit_btn upload_file">Save</button>
                </div>
            </div>
        </div>
        <input id="fileUserId" name="user_id" type="hidden" >
    </div>
    {{ Form::close() }}
    <br />
    <div class="progress">
        <div class="progress-bar" aria-valuenow="" aria-valuemin="0" aria-valuemax="100" style="width: 0%"></div >
    </div>
    <div class="row" id="success"></div>

</div>
<script>
    // $(document).ready(function() {
    //     $('Form').ajaxForm({
    //         beforeSend:function(){
    //           $('#success').empty();
    //           $('.progress-bar').text('0%');
    //           $('.progress-bar').css('width','0')
    //         },
    //         uploadProgress:function(event, position, total, percentComplete) {
    //             $('.progress-bar').text(percentComplete + '0%');
    //             $('.progress-bar').css('width', percentComplete + '0%');
    //         },
    //         success:function(data){
    //             if(data.success){
    //                 $('#success').html('<div class="text-success text-center"><b>'+data.success+'</b></div><br /><br />')
    //             }
    //         }
    //     });
    // });
    // $("#pic").change(function(){
    //     swal.fire({
    //         title: "File uploading",
    //         button: false,
    //         timer: 3000
    //     })
    // });
{{--   $("#pic").change(function() {--}}
{{--        var bar = $('.bar');--}}
{{--        var percent = $('.percent');--}}
{{--        var status = $('#status');--}}
{{--        let url = `{{route('document.upload')}}`;--}}
{{--        $('form').ajaxForm({--}}
{{--            beforeSend: function() {--}}
{{--                status.empty();--}}
{{--                var percentVal = '0%';--}}
{{--                var posterValue = $('input[name=pic]').fieldValue();--}}
{{--                bar.width(percentVal)--}}
{{--                percent.html(percentVal);--}}
{{--            },--}}
{{--            uploadProgress: function(event, position, total, percentComplete) {--}}
{{--                var percentVal = percentComplete + '%';--}}
{{--                bar.width(percentVal)--}}
{{--                percent.html(percentVal);--}}
{{--            },--}}
{{--            success: function() {--}}
{{--                var percentVal = 'Wait, Saving';--}}
{{--                bar.width(percentVal)--}}
{{--                percent.html(percentVal);--}}
{{--            },--}}
{{--            complete: function(xhr) {--}}
{{--                status.html(xhr.responseText);--}}
{{--                alert('Uploaded Successfully');--}}
{{--                // window.location.href = "document.upload";--}}
{{--            }--}}
{{--        });--}}

{{--    })();--}}

</script>

resources/views/doc/folder.blade.php
@extends('layouts.default')
@section('css')
<script src="https://cdn.jsdelivr.net/npm/sweetalert2@8"></script>
<script src="https://unpkg.com/axios/dist/axios.min.js"></script>
<style>
    .folder-wrapper > img {
        width: 110px;
    }
    .edit-icon  {
        cursor: pointer;
        display: flex;
    }
    .edit-icon .fa-pencil {
        display: none;
    }


    .folder-block {
        position: relative;
    }
    @if(auth()->user()->role != 'user')
        .folder-block:hover .delete-icon {
            display: block;
        }
    @endif
    .delete-icon {
        display: none;
        position: absolute;
        top: 10px;
        left: 85px;
        cursor: pointer;
        color: red;
    }
    .download-icon {
        display: none;
        position: absolute;
        top: 10px;
        left: 85px;
        cursor: pointer;
        color: black;
    }
    .folder-block:hover .download-icon {
        display: block;
    }

</style>
@endsection
@section('content')

    <div class="main-panel">
        <div class="main-content">
            <div class="content-wrapper">

                <section id="striped-light">
                    <div class="row">
                        <div class="col-sm-12">
                            {{-- <nav aria-label="breadcrumb" class="pt-2">
                              <ol class="breadcrumb" style="background-color:#f5f7fa;">
                               <li class="breadcrumb-item"><a href="#">Home</a></li>
                               <li class="breadcrumb-item"><a href="#">Library</a></li>
                             </ol>
                           </nav> --}}
                            <div class="card">
                                <div class="card-header">
                                    <h4 class="card-title">All Documents</h4>
                                    <hr>
                                    <form method="GET" action="" accept-charset="UTF-8" class="form form-horizontal form-bordered">
                                        <div class="form-body row">
                                            <div class="col-md-4">
                                                <input class="form-control input-lg" value="{{ empty(Request::input('name')) ? '' : Request::input('name')  }}" placeholder="Search" name="name" type="text">
                                            </div>
                                            <div class="col-md-2">
                                                <select class="form-control" name="sort">
                                                    <option value="" {{ empty(Request::input('sort')) ? 'selected' : '' }} >Sort Order: </option>
                                                    <option value="desc" {{ Request::input('sort') == 'desc' ? 'selected' : '' }}>A-Z</option>
                                                    <option value="asc" {{ Request::input('sort') == 'asc' ? 'selected' : '' }}>Z-A</option>
                                                </select>
                                            </div>
                                            <div class="col-md-2">
                                                <button type="submit" class="btn btn-info btn-success submit_btn">Filter Results</button>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                                <div class="card-content">
                                    <div id="card-body" class="card-body">
                                        <div>
                                            @include('doc/all')
                                        </div>
                                        <div id="file-section" style="display:none">
                                            @include('doc.file')
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </section>
            </div>
        </div>
    </div>
@endsection

@section('script')

    <script>
        $(document).on('click', '#new-folder', function(){
            $('#file-section').hide();
            $('#repo').show();
            let user_id = $(this).data('uid');
            createFolder(user_id);
        });

        function createFolder(user_id){
            Swal.fire({
                title: 'Create new folder',
                input: 'text',
                inputAttributes: {
                    autocapitalize: 'off'
                },
                showCancelButton: true,
                confirmButtonText: 'Create',
                showLoaderOnConfirm: true,
                preConfirm: (name) => {
                    let url = `{{route('create.folder')}}`;
                    let data = {};
                    data.name = name;
                    data.base_id = $("#parentId").val();
                    data.user_id = user_id;
                    return axios.post(url, data)
                        .then(function (response) {
                            $("#repo").empty().append(response.data);
                        })
                        .catch(function (error) {
                            console.log(error);
                        });
                },
                allowOutsideClick: () => !Swal.isLoading()
            }).then((result) => {
                console.log(result);
                if (result.success) {
                    Swal.fire({
                        title: `Folder Created`
                    })
                }
            })
        }

        $(document).on('click', '.edit-name', function(e){
            e.preventDefault();
            e.stopPropagation();

        });

        $(document).on('click', '.open-folder', function(e){
            e.preventDefault();
            e.stopPropagation();

            let id = $(this).data('id');
            let url = `{{route('get.subfolders')}}`;
            let data = {};
            data.base_id = id;
            data.user_id = $(this).closest('.folder').find('.folder_user_id').val();
            axios.post(url, data)
                .then(function (response) {

                    $("#repo").empty().append(response.data);
                })
                .catch(function (error) {
                    console.log(error);
                });
        });

        function deleteFolder(data){
            Swal.fire({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
                let url = `{{route('delete.folder')}}`;
                if (result.value) {
                    axios.post(url, data)
                        .then(function (response) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            );

                            location.reload(true);
                        })
                        .catch(function (error) {
                            console.log(error);
                        });
                }
            })
        }

        $(document).on('click', '.delete-icon', function(e){

            e.preventDefault();
            e.stopPropagation();
            let folder = $(this).closest('.folder').find('.folder-id').val();
            let data = {};
            data.id = folder;
            data.user_id = $(this).closest('.folder').find('.folder_user_id').val();
            deleteFolder(data);
        });

        $(document).on('click', '#open-file-section', function(e){

            let user_id = $(this).data('uid');
            $("#fileUserId").val(user_id);
            $('#file-section').show(600);
            $('#repo-hide').hide(600);

        });

        $(document).on('submit', '#document_upload', function(e){
            e.preventDefault();
            let parent = $("#parentId").val();
            let formData = new FormData(this);
            formData.append('base_id', parent);
            formData.append('app_id', '{{ app('request')->input('app_id') }}');
            let url = `{{route('document.upload')}}`;
            $.ajax({
                beforeSend:function(){
                    $('#success').empty();
                    $('.progress-bar').text('0%');
                    $('.progress-bar').css('width','0')
                },
                uploadProgress:function(event, position, total, percentComplete) {
                    $('.progress-bar').text(percentComplete + '0%');
                    $('.progress-bar').css('width', percentComplete + '0%');
                },
                success:function(data){
                        // $('#success').html('<div class="text-success text-center"><b>' + data.success + '</b></div><br /><br />')
                        $('#success').append();
                        $('.progress-bar').text('Uploaded');
                        $('.progress-bar').css('width', '100%');
                },
            });
            $.ajax({
                type: 'POST',
                url: url,
                data: formData,
                dataType: 'html',
                contentType: false,
                cache: false,
                processData:false,
                beforeSend: function(){

                },
                success: function(response){
                    $.notify("File Uploaded Successfully.","success");
                    var x = $(response).find('#files-area');
                    // $("#repo").hide(600);

                    // $("#repo").hide();
                    // $(".all-folders-row").style.display = "none";
                    // $(".all-folders-row").hide();
                    // $(".open-folder .folder-wrapper").style.display= "none";
                    $(".card-content").append(x);
                    // $(".files-area").show();
                    // $(".folder-wrapper").hide(600);

                    // $('#folder-area').hide(5000);
                },
                error: function(response) {
                    var res = JSON.parse(response.responseText);
                    console.log(res);
                    $.notify(res.error);
                }

            });

            setTimeout(function () {
                window.location.reload(1);
            }, 2000);
        });


        $(document).on('click', '.delete-file', function(e){

            e.preventDefault();
            e.stopPropagation();
            let file = $(this).closest('.folder').find('.file-id').val();
            let data = {};
            data.id = file;
            data.user_id = $(this).closest('.folder').find('.file_user_id').val();
            deleteFile(data);
        });

        function deleteFile(data){
            Swal.fire({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!'
            }).then((result) => {
                let url = `{{route('delete.file')}}`;
                if (result.value) {
                    alert(result);
                    axios.post(url, data)
                        .then(function (response) {
                            Swal.fire(
                                'Deleted!',
                                'Your file has been deleted.',
                                'success'
                            );

                            location.reload(true);
                            // window.location.reload(false);
                        })
                        .catch(function (error) {
                            console.log(error);
                        });

                }
            })
        }

    </script>

@endsection